/*
 * DRCint.h --
 *
 * Definitions internal to the DRC module.
 *
 *     ********************************************************************* 
 *     * Copyright (C) 1985, 1990 Regents of the University of California. * 
 *     * Permission to use, copy, modify, and distribute this              * 
 *     * software and its documentation for any purpose and without        * 
 *     * fee is hereby granted, provided that the above copyright          * 
 *     * notice appear in all copies.  The University of California        * 
 *     * makes no representations about the suitability of this            * 
 *     * software for any purpose.  It is provided "as is" without         * 
 *     * express or implied warranty.  Export of this software outside     * 
 *     * of the United States of America may require an export license.    * 
 *     *********************************************************************
 *
 * Needs to include: magic.h database.h
 *
 * rcsid $Header: /ufs/repository/magic/drc/DRCint.h,v 1.2 2006/02/08 03:46:17 fang Exp $
 */

#ifndef	__DRC_DRCINT_H__
#define	__DRC_DRCINT_H__

#include "utils/geometry_types.h"
#include "database/database_types.h"
#include "tiles/tile_types.h"

extern int
DRCBasicCheck(CellDef *celldef, Rect *checkRect, Rect *clipRect,
	void (*function)(), ClientData cdata);

extern int
DRCArrayCheck(CellDef *def, Rect *area, void (*func)(), ClientData cdarg);

/* from "drc/DRCsubcell.c" */

extern int
DRCInteractionCheck(CellDef *def, Rect *area, void (*func)(), ClientData cdarg);

/* from "drc/DRCcif.c" */

extern void
drcCifCheck(struct drcClientData *arg);

/* from "drc/DRCextend.c" */

extern int
drcCheckArea(Tile *starttile, struct drcClientData *arg, DRCCookie *cptr);

extern int
drcCheckMaxwidth(Tile *starttile, struct drcClientData *arg, DRCCookie *cptr);

extern int
drcCheckRectSize(Tile *starttile, struct drcClientData *arg, DRCCookie *cptr);


#endif	/* __DRC_DRCINT_H__ */


