/*
 * routerInt.h -
 *
 *	Internal definitions for Router module.
 *
 *     ********************************************************************* 
 *     * Copyright (C) 1985, 1990 Regents of the University of California. * 
 *     * Permission to use, copy, modify, and distribute this              * 
 *     * software and its documentation for any purpose and without        * 
 *     * fee is hereby granted, provided that the above copyright          * 
 *     * notice appear in all copies.  The University of California        * 
 *     * makes no representations about the suitability of this            * 
 *     * software for any purpose.  It is provided "as is" without         * 
 *     * express or implied warranty.  Export of this software outside     * 
 *     * of the United States of America may require an export license.    * 
 *     *********************************************************************
 *
 * rcsid="$Header: /ufs/repository/magic/router/routerInt.h,v 1.3 2006/02/08 03:48:18 fang Exp $" 
 */

/*
 *	Declarations local to the router module,
 *	but global to all source files within the router module.
 */

#ifndef _ROUTER_INT
#define _ROUTER_INT

#include "utils/geometry_types.h"
#include "gcr/gcr_types.h"

extern int	rtrTarget;			/* Via minimization, target type	*/
extern int	rtrReplace;			/* Via minimization, replacement type	*/
extern int	rtrDelta;			/* Change in layer width		*/

/* internal prototypes */
extern void RtrChannelBounds(Rect*, int*, int*, Point*);
extern void RtrPinsFixStems(GCRChannel*);
extern int rtrSrTraverse(CellDef*, Rect*, TileTypeBitMask*, TileTypeBitMask*,
	Rect*, int (*)(), ClientData);
extern int rtrListVia(Tile*);
extern void rtrListArea(Tile*, int, int, int, int);

#endif
